/* global Ladda, icon */

"use strict";

$(document).ready(() => {
	initSelect2();
	eventos.init()
	defaultConfigDataTable()
	contratos.init()
});

// INICIALIZACION
//========================================

/** inicializa el select */
function initSelect2() {
	$('.select').select2({
		minimumResultsForSearch: Infinity
	});
}

const contratos = {
	init() {
		this.listarContrato()
	},
	listarContrato(json = {}) {
		$('#tblContrato').DataTable().destroy()
		$('#tblContrato').DataTable({
			ajax: {
				url: '../ContratoServlet?accion=listarContrato',
				type: 'POST',
				dataType: 'JSON',
				data: {
					json: JSON.stringify(json)
				}
			},
			processing: true,
			serverSide: true,
			responsive: true,
			iDisplayLength: 20,
			columns: [
				{data: "nombrePersonal"},
				{
					data: null,
					render: (data) => {
						return `${data.tipoDocumentoIdentidad} - ${data.documentoIdentidad}`
					}
				},
				{data: "areaLaboral"},
				{data: "cargoLaboral"},
				{data: "fechaInicio"},
				{
					data: "tipoContrato",
					render: (data) => data || ''
				},
				{
					data: "razonSocial",
					render: (data) => data || ''
				},
				{
					data: "estadoContrato",
					className: 'text-center'
				},
				{
					data: 'codigoEstadoContrato',
					className: 'text-center',
					render: (data) => {
						let accion = `<ul class="icons-list">`
						if (data != 1) {
							accion += `
								<li><a class="btnVerPdf"><i class="fa fa-file-pdf-o text-danger"></i></a></li>
							`
						}
						accion += `</ul>`
						return accion
					}
				}
			],
			initComplete: () => {
				eventos.verPdf()
			}
		})
	}
}

const eventos = {
	init() {
		this.buscarContrato()
	},
	buscarContrato() {
		querySelector('#btnBuscarContrato').addEventListener('click', () => {
			let params = cleanQueryParams({
				numeroDocumento: querySelector('#txtNumeroDocumentoIdentidad').value,
				apellido: querySelector('#txtApellidos').value,
				estado: querySelector('#cboEstadoContratoPlanilla').value,
				tipo: querySelector('#cboTipoContratoPlanilla').value,
				razonSocial: querySelector('#cboRazonSocial').value,
				tipoTrabajador: querySelector('#cboTipoTrabajador').value
			})

			contratos.listarContrato(params)
		})
	},
	verPdf() {
		$('.btnVerPdf').off().on('click', (e) => {
			let dataRow = $('#tblContrato').DataTable().row($(e.currentTarget).parents('tr')).data()
			$('#data').val(JSON.stringify(dataRow));
			$('#formPDF').submit();

//			$.ajax({
//				url: '../ContratoServlet?accion=contratoPdf',
//				type: 'POST',
//				dataType: 'pdf',
//				data: {
//					json: JSON.stringify(dataRow)
//				}
//			})
		})
	}
}

const querySelector = (node) => document.querySelector(node)

const querySelectorAll = (node) => document.querySelectorAll(node)

const cleanQueryParams = (params = {}) => {
	for (var key in params) {
		if (params.hasOwnProperty(key)) {
			if (!params[key]) {
				delete params[key];
			}
		}
	}

	return params;
}
